import{S as Ze,i as et,s as tt,e as a,k as d,w as x,t as i,M as st,c as n,d as s,m as u,a as r,x as A,h as f,b as l,G as t,g as b,y as P,q as I,o as q,B as D,v as at,L as nt}from"../../chunks/vendor-hf-doc-builder.js";import{D as ce}from"../../chunks/Docstring-hf-doc-builder.js";import{C as rt}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Ye}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as ot}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function lt(se){let m,H,g,p,v;return p=new rt({props:{code:`import hffs

fs = hffs.HfFileSystem()

# List files
fs.glob("my-username/my-model/*.bin")
fs.ls("datasets/my-username/my-dataset", detail=False)

# Read/write files
with fs.open("my-username/my-model/pytorch_model.bin") as f:
    data = f.read()
with fs.open("my-username/my-model/pytorch_model.bin", "wb") as f:
    f.write(data)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> hffs

<span class="hljs-meta">&gt;&gt;&gt; </span>fs = hffs.HfFileSystem()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># List files</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>fs.glob(<span class="hljs-string">&quot;my-username/my-model/*.bin&quot;</span>)
[<span class="hljs-string">&#x27;my-username/my-model/pytorch_model.bin&#x27;</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>fs.ls(<span class="hljs-string">&quot;datasets/my-username/my-dataset&quot;</span>, detail=<span class="hljs-literal">False</span>)
[<span class="hljs-string">&#x27;datasets/my-username/my-dataset/.gitattributes&#x27;</span>, <span class="hljs-string">&#x27;datasets/my-username/my-dataset/README.md&#x27;</span>, <span class="hljs-string">&#x27;datasets/my-username/my-dataset/data.json&#x27;</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Read/write files</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> fs.<span class="hljs-built_in">open</span>(<span class="hljs-string">&quot;my-username/my-model/pytorch_model.bin&quot;</span>) <span class="hljs-keyword">as</span> f:
<span class="hljs-meta">... </span>    data = f.read()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> fs.<span class="hljs-built_in">open</span>(<span class="hljs-string">&quot;my-username/my-model/pytorch_model.bin&quot;</span>, <span class="hljs-string">&quot;wb&quot;</span>) <span class="hljs-keyword">as</span> f:
<span class="hljs-meta">... </span>    f.write(data)`}}),{c(){m=a("p"),H=i("Usage:"),g=d(),x(p.$$.fragment)},l(o){m=n(o,"P",{});var $=r(m);H=f($,"Usage:"),$.forEach(s),g=u(o),A(p.$$.fragment,o)},m(o,$){b(o,m,$),t(m,H),b(o,g,$),P(p,o,$),v=!0},p:nt,i(o){v||(I(p.$$.fragment,o),v=!0)},o(o){q(p.$$.fragment,o),v=!1},d(o){o&&s(m),o&&s(g),D(p,o)}}}function it(se){let m,H,g,p,v,o,$,z,me,ae,w,pe,K,he,ge,L,Q,de,ue,ne,E,j,X,N,ye,Y,_e,re,y,Z,be,ve,C,$e,we,U,Ee,Fe,O,He,je,oe,c,R,Se,ee,ke,xe,S,Ae,G,T,Pe,J,M,Ie,k,V,qe,te,De,le;return o=new Ye({}),N=new Ye({}),R=new ce({props:{name:"class huggingface_hub.HfFileSystem",anchor:"huggingface_hub.HfFileSystem",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"huggingface_hub.HfFileSystem.endpoint",description:`<strong>endpoint</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The endpoint to use. If not provided, the default one (<a href="https://huggingface.co" rel="nofollow">https://huggingface.co</a>) is used.`,name:"endpoint"},{anchor:"huggingface_hub.HfFileSystem.token",description:`<strong>token</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Authentication token, obtained with <code>HfApi.login</code> method. Will default to the stored token.`,name:"token"}],source:"https://github.com/huggingface/huggingface_hub/blob/v0.14.1/src/huggingface_hub/hf_file_system.py#L44"}}),S=new ot({props:{anchor:"huggingface_hub.HfFileSystem.example",$$slots:{default:[lt]},$$scope:{ctx:se}}}),T=new ce({props:{name:"__init__",anchor:"huggingface_hub.HfFileSystem.__init__",parameters:[{name:"*args",val:""},{name:"endpoint",val:": typing.Optional[str] = None"},{name:"token",val:": typing.Optional[str] = None"},{name:"**storage_options",val:""}],source:"https://github.com/huggingface/huggingface_hub/blob/v0.14.1/src/huggingface_hub/hf_file_system.py#L78"}}),M=new ce({props:{name:"resolve_path",anchor:"huggingface_hub.HfFileSystem.resolve_path",parameters:[{name:"path",val:": str"},{name:"revision",val:": typing.Optional[str] = None"}],source:"https://github.com/huggingface/huggingface_hub/blob/v0.14.1/src/huggingface_hub/hf_file_system.py#L113"}}),V=new ce({props:{name:"ls",anchor:"huggingface_hub.HfFileSystem.ls",parameters:[{name:"path",val:": str"},{name:"detail",val:": bool = True"},{name:"refresh",val:": bool = False"},{name:"revision",val:": typing.Optional[str] = None"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/huggingface_hub/blob/v0.14.1/src/huggingface_hub/hf_file_system.py#L244"}}),{c(){m=a("meta"),H=d(),g=a("h1"),p=a("a"),v=a("span"),x(o.$$.fragment),$=d(),z=a("span"),me=i("Filesystem API"),ae=d(),w=a("p"),pe=i("The "),K=a("code"),he=i("HfFileSystem"),ge=i(" class provides a pythonic file interface to the Hugging Face Hub based on "),L=a("a"),Q=a("code"),de=i("fssepc"),ue=i("."),ne=d(),E=a("h2"),j=a("a"),X=a("span"),x(N.$$.fragment),ye=d(),Y=a("span"),_e=i("HfFileSystem"),re=d(),y=a("p"),Z=a("code"),be=i("HfFileSystem"),ve=i(" is based on "),C=a("a"),$e=i("fsspec"),we=i(", so it is compatible with most of the APIs that it offers. For more details, check out "),U=a("a"),Ee=i("our guide"),Fe=i(" and the fsspec\u2019s "),O=a("a"),He=i("API Reference"),je=i("."),oe=d(),c=a("div"),x(R.$$.fragment),Se=d(),ee=a("p"),ke=i("Access a remote Hugging Face Hub repository as if were a local file system."),xe=d(),x(S.$$.fragment),Ae=d(),G=a("div"),x(T.$$.fragment),Pe=d(),J=a("div"),x(M.$$.fragment),Ie=d(),k=a("div"),x(V.$$.fragment),qe=d(),te=a("p"),De=i("List the contents of a directory."),this.h()},l(e){const h=st('[data-svelte="svelte-1phssyn"]',document.head);m=n(h,"META",{name:!0,content:!0}),h.forEach(s),H=u(e),g=n(e,"H1",{class:!0});var B=r(g);p=n(B,"A",{id:!0,class:!0,href:!0});var Le=r(p);v=n(Le,"SPAN",{});var Ne=r(v);A(o.$$.fragment,Ne),Ne.forEach(s),Le.forEach(s),$=u(B),z=n(B,"SPAN",{});var Ce=r(z);me=f(Ce,"Filesystem API"),Ce.forEach(s),B.forEach(s),ae=u(e),w=n(e,"P",{});var W=r(w);pe=f(W,"The "),K=n(W,"CODE",{});var Oe=r(K);he=f(Oe,"HfFileSystem"),Oe.forEach(s),ge=f(W," class provides a pythonic file interface to the Hugging Face Hub based on "),L=n(W,"A",{href:!0,rel:!0});var Re=r(L);Q=n(Re,"CODE",{});var Te=r(Q);de=f(Te,"fssepc"),Te.forEach(s),Re.forEach(s),ue=f(W,"."),W.forEach(s),ne=u(e),E=n(e,"H2",{class:!0});var ie=r(E);j=n(ie,"A",{id:!0,class:!0,href:!0});var Me=r(j);X=n(Me,"SPAN",{});var Ve=r(X);A(N.$$.fragment,Ve),Ve.forEach(s),Me.forEach(s),ye=u(ie),Y=n(ie,"SPAN",{});var Be=r(Y);_e=f(Be,"HfFileSystem"),Be.forEach(s),ie.forEach(s),re=u(e),y=n(e,"P",{});var F=r(y);Z=n(F,"CODE",{});var Ue=r(Z);be=f(Ue,"HfFileSystem"),Ue.forEach(s),ve=f(F," is based on "),C=n(F,"A",{href:!0,rel:!0});var Ge=r(C);$e=f(Ge,"fsspec"),Ge.forEach(s),we=f(F,", so it is compatible with most of the APIs that it offers. For more details, check out "),U=n(F,"A",{href:!0});var Je=r(U);Ee=f(Je,"our guide"),Je.forEach(s),Fe=f(F," and the fsspec\u2019s "),O=n(F,"A",{href:!0,rel:!0});var We=r(O);He=f(We,"API Reference"),We.forEach(s),je=f(F,"."),F.forEach(s),oe=u(e),c=n(e,"DIV",{class:!0});var _=r(c);A(R.$$.fragment,_),Se=u(_),ee=n(_,"P",{});var ze=r(ee);ke=f(ze,"Access a remote Hugging Face Hub repository as if were a local file system."),ze.forEach(s),xe=u(_),A(S.$$.fragment,_),Ae=u(_),G=n(_,"DIV",{class:!0});var Ke=r(G);A(T.$$.fragment,Ke),Ke.forEach(s),Pe=u(_),J=n(_,"DIV",{class:!0});var Qe=r(J);A(M.$$.fragment,Qe),Qe.forEach(s),Ie=u(_),k=n(_,"DIV",{class:!0});var fe=r(k);A(V.$$.fragment,fe),qe=u(fe),te=n(fe,"P",{});var Xe=r(te);De=f(Xe,"List the contents of a directory."),Xe.forEach(s),fe.forEach(s),_.forEach(s),this.h()},h(){l(m,"name","hf:doc:metadata"),l(m,"content",JSON.stringify(ft)),l(p,"id","filesystem-api"),l(p,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(p,"href","#filesystem-api"),l(g,"class","relative group"),l(L,"href","https://filesystem-spec.readthedocs.io/en/latest/"),l(L,"rel","nofollow"),l(j,"id","huggingface_hub.HfFileSystem"),l(j,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(j,"href","#huggingface_hub.HfFileSystem"),l(E,"class","relative group"),l(C,"href","https://filesystem-spec.readthedocs.io/en/latest/"),l(C,"rel","nofollow"),l(U,"href","../guides/filesystem"),l(O,"href","https://filesystem-spec.readthedocs.io/en/latest/api.html#fsspec.spec.AbstractFileSystem"),l(O,"rel","nofollow"),l(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(c,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,h){t(document.head,m),b(e,H,h),b(e,g,h),t(g,p),t(p,v),P(o,v,null),t(g,$),t(g,z),t(z,me),b(e,ae,h),b(e,w,h),t(w,pe),t(w,K),t(K,he),t(w,ge),t(w,L),t(L,Q),t(Q,de),t(w,ue),b(e,ne,h),b(e,E,h),t(E,j),t(j,X),P(N,X,null),t(E,ye),t(E,Y),t(Y,_e),b(e,re,h),b(e,y,h),t(y,Z),t(Z,be),t(y,ve),t(y,C),t(C,$e),t(y,we),t(y,U),t(U,Ee),t(y,Fe),t(y,O),t(O,He),t(y,je),b(e,oe,h),b(e,c,h),P(R,c,null),t(c,Se),t(c,ee),t(ee,ke),t(c,xe),P(S,c,null),t(c,Ae),t(c,G),P(T,G,null),t(c,Pe),t(c,J),P(M,J,null),t(c,Ie),t(c,k),P(V,k,null),t(k,qe),t(k,te),t(te,De),le=!0},p(e,[h]){const B={};h&2&&(B.$$scope={dirty:h,ctx:e}),S.$set(B)},i(e){le||(I(o.$$.fragment,e),I(N.$$.fragment,e),I(R.$$.fragment,e),I(S.$$.fragment,e),I(T.$$.fragment,e),I(M.$$.fragment,e),I(V.$$.fragment,e),le=!0)},o(e){q(o.$$.fragment,e),q(N.$$.fragment,e),q(R.$$.fragment,e),q(S.$$.fragment,e),q(T.$$.fragment,e),q(M.$$.fragment,e),q(V.$$.fragment,e),le=!1},d(e){s(m),e&&s(H),e&&s(g),D(o),e&&s(ae),e&&s(w),e&&s(ne),e&&s(E),D(N),e&&s(re),e&&s(y),e&&s(oe),e&&s(c),D(R),D(S),D(T),D(M),D(V)}}}const ft={local:"filesystem-api",sections:[{local:"huggingface_hub.HfFileSystem",title:"HfFileSystem"}],title:"Filesystem API"};function ct(se){return at(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ut extends Ze{constructor(m){super();et(this,m,ct,it,tt,{})}}export{ut as default,ft as metadata};
